/**
 * Copyright (C) 2008  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.console.webui.novaview;

import java.util.List;

import org.exoplatform.webui.application.WebuiRequestContext;
import org.exoplatform.webui.config.annotation.ComponentConfig;
import org.exoplatform.webui.core.UIComponent;

/**
 * UINovaViewer is the component who manage the
 * 
 * @author Le Gall Rodrigue <rodrigue.le-gall@bull.net>
 * @author Elwalid BRAHIM <elwalid.brahim@bull.net>
 */
@ComponentConfig(template = "system:/groovy/novabpm/commons/webui/UINovaViewer.gtmpl")
public class UINovaViewer extends UIComponent {

  /**
   * This method allow to request render (if possible) for all the childs of
   * nova view manager.
   * 
   * @throws Exception
   */
  public void renderViews() throws Exception {
    WebuiRequestContext context = WebuiRequestContext.getCurrentInstance();
    renderViews(context);
  }

  /**
   * This method allow to request render (if possible) for all the childs of
   * nova view manager.
   * 
   * @param context
   * @throws Exception
   */
  public void renderViews(WebuiRequestContext context) throws Exception {
    UINovaViewManagement viewMgt = (UINovaViewManagement) getParent();
    List<UIComponent> list = viewMgt.getChildren();
    for (UIComponent child : list) {
      if (UINovaViewContainer.class.isInstance(child)) {
        UINovaViewContainer container = UINovaViewContainer.class.cast(child);
        if (container.isRendered()) {
          container.processRenderView(context);
        }
      }
    }
  }
}
